function [h_angle,h_length]=estimate_motion(image)
%
% [angle, length]=estimate_motion(image)
%
step=2;
% Compute FFT2 of image
Image=log(abs(fftshift(fft2(image))));

% Compute exact radon
radon_image=radon2(Image);

% Crop the Radon transform
mid_elemt=round(size(radon_image,1)/2);
mid_size=floor(min(size(image))/4*sqrt(2))-1;
radon_image=radon_image(mid_elemt-mid_size:mid_elemt+mid_size,:);

% Estimate the angle
h_angle=motion_angle(radon_image);

% Estimate de length
h_length=motion_length(radon_image(:,h_angle+1),h_angle,size(image),step);